/*
 * Copyright 2016 - 2022 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include "undostack.hpp"

namespace nostalgia::studio {

void UndoStack::push(UndoCommand *cmd) noexcept {
	for (const auto i = m_stackIdx; i < m_stack.size();) {
		oxIgnoreError(m_stack.erase(i));
	}
	m_stack.emplace_back(cmd);
	++m_stackIdx;
	cmd->redo();
}

void UndoStack::redo() noexcept {
	if (m_stackIdx < m_stack.size()) {
		m_stack[m_stackIdx++]->redo();
	}
	redoTriggered.emit();
}

void UndoStack::undo() noexcept {
	if (m_stackIdx) {
		m_stack[--m_stackIdx]->undo();
	}
	undoTriggered.emit();
}

}